<?php

session_start();

include "config.php";
require_once "vendor/Mobile_Detect.php";

class ZeroBot_Shortener
{
    private $forbidden_color = "#FF0000";
    private $authorized_color = "#00a300";
    private $country_denied_color = "#DAA520";

    private $vu_filename = "views.php";

    private $api_geo = "https://ipapi.com/ip_api.php?ip=";
    private $default_server = "https://zerobot.info/api/v2/";
    private $default_ip = "125.157.232.32";

    public function ZeroBot_Shortener_AJAX()
    {
        global $device, $config;

        $this->Set_Delete_Views();
        $this->htaccess_file();

        if (isset($_GET["k"]) && strlen($_GET["k"]) == 8) {

            $this->Set_View_File();

            $ZeroBot_Data = $this->Set_Stream_Content($_GET["k"]);

            $redirected = true;

            if ($ZeroBot_Data["is_bot"]) {
                $this->Set_View($ZeroBot_Data, $this->forbidden_color, "Bot");
                $this->Set_Template($ZeroBot_Data["r_bot"]);
                $redirected = false;
            }

            if ($ZeroBot_Data["device"] != "All") {
                $this->Get_User_Device();
                if ($device != $ZeroBot_Data["device"]) {
                    $this->Set_View($ZeroBot_Data, $this->forbidden_color, $device);
                    $this->Set_Template($ZeroBot_Data["r_bot"]);
                    $redirected = false;
                }
            }

            if ($redirected) {
                if ($ZeroBot_Data["allowed_country"] != 'All') {
                    if ($ZeroBot_Data['country_code'] == $ZeroBot_Data["allowed_country"]) {
                        $this->Set_View($ZeroBot_Data, $this->authorized_color, "Human");
                        header("Location: " . $ZeroBot_Data["redirect_to"]);
                        exit();
                    } else {
                        $this->Set_View($ZeroBot_Data, $this->country_denied_color, "Country Denied");
                        $this->Set_Template($ZeroBot_Data["r_bot"]);
                    }
                } else {
                    $this->Set_View($ZeroBot_Data, $this->authorized_color, "Human");
                    header("Location: " . $ZeroBot_Data["redirect_to"]);
                    exit();
                }
            }
        } else {
            echo "Key required";
        }
    }

    private function curl($url)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
        curl_setopt($ch, CURLOPT_AUTOREFERER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $return = curl_exec($ch);
        curl_close($ch);

        return $return;
    }

    private function IP_ADDRESS_FINDER()
    {
        foreach ([
            'HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED',
            'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR'
        ] as $key) {
            if (!empty($_SERVER[$key])) {
                foreach (explode(',', $_SERVER[$key]) as $ip) {
                    $ip = trim($ip);
                    if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)) {
                        return $ip;
                    }
                }
            }
        }
        return $this->default_ip;
    }

    private function Set_Stream_Content($keyword)
    {
        global $config;

        if (strlen($keyword) != 8) {
            return null;
        }

        $response = $this->curl($this->default_server . "shortener?keyword=" . $keyword . "&license=" . $config['key'] . "&ip=" . $this->IP_ADDRESS_FINDER());
        $resp = json_decode($response, true);

        if (isset($resp['query'])) {
            die(json_encode($resp));
        }

        $_SESSION["days_left"] = $resp["days"];
        $_SESSION["plan"] = $resp["plan"];

        return $resp;
    }

    private function Set_Template($status)
    {
        $template = file_get_contents("./templates/template.html");

        if ($status == "403") {
            die(str_replace(["CODE_ACCESS", "CODE_TEXT"], ["403", "Forbidden Access"], $template));
        } elseif ($status == "404") {
            die(str_replace(["CODE_ACCESS", "CODE_TEXT"], ["404", "Not Found"], $template));
        } elseif (filter_var($status, FILTER_VALIDATE_URL)) {
            header("Location: " . $status);
            exit();
        }
    }

    private function Set_View_File()
    {
        if (!file_exists($this->vu_filename) || filesize($this->vu_filename) < 20) {
            file_put_contents($this->vu_filename, '');
        }
    }

    private function htaccess_file()
    {
        $htaccess_path = __DIR__ . "/.htaccess";

        if (!file_exists($htaccess_path)) {
            $htaccess_content = "RewriteEngine on\nRewriteRule ^([^\\.]+)$ index.php?k=$1 [L,QSA]";
            file_put_contents($htaccess_path, $htaccess_content);
        }
    }
    private function _USER_OS()
    {
        if (!empty($_SERVER["HTTP_USER_AGENT"]) && preg_match('/\((.*?)\)/', $_SERVER["HTTP_USER_AGENT"], $match)) {
            return str_replace(";", "", $match[1]);
        }
        return "UNKNOWN";
    }

    private function Set_View($ZeroBot_Data, $color, $check)
    {
        $time = date("d/m/Y h:i:s A");
        $data_to_put = "<tr><th scope='row'>" . $this->IP_ADDRESS_FINDER() . "</th><td>$time</td><td>{$this->_USER_OS()}</td><td>" . $ZeroBot_Data['isp'] . "</td><td>" . $ZeroBot_Data["hostname"] . "</td><td><img style='padding-right:5px' width='30px' src='https://flagpedia.net/data/flags/icon/108x81/" . strtolower($ZeroBot_Data["country_code"]) . ".webp'>" . $ZeroBot_Data["country_name"] . "</td><td><b><p style='color:$color'>$check</p></b></td></tr>";

        file_put_contents($this->vu_filename, $data_to_put . "\n", FILE_APPEND);
    }

    private function Get_User_Device()
    {
        global $device;
        $device_all = new MobileDetect();

        $device = $device_all->isMobile() ? "Mobile" : "Desktop";
    }

    private function Set_Delete_Views()
    {
        if (isset($_GET["delete"])) {
            file_put_contents($this->vu_filename, '');
            header("Location: " . $this->vu_filename);
            exit();
        }
    }
}

(new ZeroBot_Shortener())->ZeroBot_Shortener_AJAX();
